import { PromotedObjectType, SiteSetEnum } from "@/services/launchAdq/enum"
import React from "react"
import { Image, Space } from "antd"


export const adcreativeTemplate = [
    {adcreativeTemplateAppellation: "常规大图 1:1", adcreativeTemplateId: 311},
    {adcreativeTemplateAppellation: "常规视频  4:3", adcreativeTemplateId: 618},
    {adcreativeTemplateAppellation: "常规多图 1:1 三图", adcreativeTemplateId: 641},
    {adcreativeTemplateAppellation: "常规多图 1:1 四图", adcreativeTemplateId: 642},
    {adcreativeTemplateAppellation: "常规多图 1:1 六图", adcreativeTemplateId: 643},
    {adcreativeTemplateAppellation: "横版视频 16:9", adcreativeTemplateId: 720},
    {adcreativeTemplateAppellation: "竖版视频 9:16", adcreativeTemplateId: 721},
    {adcreativeTemplateAppellation: "常规视频 750×1536", adcreativeTemplateId: 1064},
    {adcreativeTemplateAppellation: "常规视频 16:9", adcreativeTemplateId: 1465},
    {adcreativeTemplateAppellation: "常规视频 9:16", adcreativeTemplateId: 1480},
    {adcreativeTemplateAppellation: "卡片广告 横版大图 16:9", adcreativeTemplateId: 1707},
    {adcreativeTemplateAppellation: "卡片广告 横版视频 16:9", adcreativeTemplateId: 1708},
    {adcreativeTemplateAppellation: "破框形态 视频合约广告", adcreativeTemplateId: 1885},
    {adcreativeTemplateAppellation: "横版大图 16:9", adcreativeTemplateId: 711},
    {adcreativeTemplateAppellation: "竖版大图 9:16", adcreativeTemplateId: 712},
    {adcreativeTemplateAppellation: "横版视频 16:9", adcreativeTemplateId: 720},
    {adcreativeTemplateAppellation: "竖版视频 9:16", adcreativeTemplateId: 721},
    {adcreativeTemplateAppellation: "激励浏览广告", adcreativeTemplateId: 910},
    {adcreativeTemplateAppellation: "Banner图片 20:7", adcreativeTemplateId: 925},
    {adcreativeTemplateAppellation: "出框形态 视频合约广告", adcreativeTemplateId: 1945}
]

/**
 * 创意详情
 */
interface Props {
    data: any
}
const AdcreativeCol: React.FC<Props> = (props) => {

    /***************************/
    const { data } = props
    const { adcreativeName, promotedObjectType, siteSet, adcreativeTemplateId, adcreativeElements } = data
    /***************************/

    return <>
        <div>创意名称: <span>{adcreativeName}</span></div>
        <div>推广目标: <span>{PromotedObjectType[promotedObjectType]}</span></div>
        <div>广告版位: <span>{siteSet?.map((item: string) => SiteSetEnum[item]).toString()}</span></div>
        <div>创意形式: <span>{adcreativeTemplate?.find((item: any) => item?.adcreativeTemplateId === adcreativeTemplateId)?.adcreativeTemplateAppellation || ''}</span></div>
        {adcreativeElements?.description && <div>创意文案: <span>{adcreativeElements?.description}</span></div>}
        {adcreativeElements?.title && <div>文案: <span>{adcreativeElements?.title}</span></div>}
        {adcreativeElements?.imageUrl && <div style={{ display: 'flex', alignItems: 'flex-start',marginBottom:4 }}>创意素材: <Image width={80} src={adcreativeElements?.imageUrl} style={{ borderRadius: 8, overflow: 'hidden', marginLeft: 5 }} /></div>}
        {adcreativeElements?.imageUrlList && <div style={{ display: 'flex', alignItems: 'flex-start', flexWrap: 'wrap' }}><span style={{ marginRight: 4 }}>创意素材:</span> <Image.PreviewGroup>
            <Space wrap>
                {adcreativeElements?.imageUrlList?.map((url: string, index: number) => <Image width={50} src={url} style={{ borderRadius: 4 }} key={'TOP_SLIDER' + index} />)}
            </Space>
        </Image.PreviewGroup></div>}
        {adcreativeElements?.shortVideoStruct?.shortVideo1Url && <div style={{ display: 'flex', alignItems: 'flex-start' }}><span style={{ marginRight: 4 }}>创意素材:</span> <video src={adcreativeElements?.shortVideoStruct?.shortVideo1Url} width={130} controls></video></div>}
        {adcreativeElements?.videoUrl && <div style={{ display: 'flex', alignItems: 'flex-start' }}><span style={{ marginRight: 4 }}>创意素材:</span> <video src={adcreativeElements?.videoUrl} width={130} controls></video></div>}
    </>
}

export default React.memo(AdcreativeCol)