import { AdStatus, BidModeEnum, BidStrategyEnum, OptimizationGoalEnum, PromotedObjectType, SiteSetEnum } from "@/services/launchAdq/enum"
import React from "react"


interface Props {
    data: any
}
/**
 * 广告基本信息展示
 * @returns 
 */
const AdgroupsCol = React.forwardRef((props: Props, ref) => {

    /*************************/
    const { data } = props
    const { adgroupName, promotedObjectType, siteSet, endDate, beginDate, bidMode, optimizationGoal, smartBidType, bidStrategy, bidAmount, dailyBudget ,firstDayBeginTime,configuredStatus} = data
    /*************************/

    return <>
        <div>广告名称: <span>{adgroupName}</span></div>
        <div>推广目标: <span>{PromotedObjectType[promotedObjectType]}</span></div>
        <div>广告版位: <span>{siteSet?.map((item: string) => SiteSetEnum[item]).toString()}</span></div>
        <div>投放日期: <span>{endDate ? beginDate + '~' + endDate : beginDate + '~' + '长期投放'}</span></div>
        {firstDayBeginTime && <div>首日时间: <span>{firstDayBeginTime}</span></div>}
        <div>出价方式: <span>{BidModeEnum[bidMode]}</span></div>
        {optimizationGoal && <div>优化目标: <span>{OptimizationGoalEnum[optimizationGoal]}</span></div>}
        <div>出价类型: <span>{smartBidType === 'SMART_BID_TYPE_CUSTOM' ? '手动出价' : '自动出价'}</span></div>
        {bidStrategy && <div>出价策略: <span>{BidStrategyEnum[bidStrategy]}</span></div>}
        <div>广告出价: <span>{bidAmount}{`元/${OptimizationGoalEnum[optimizationGoal] || '千次曝光'}`}</span></div>
        <div>广告日预算: <span>{dailyBudget || '不限'}</span></div>
        <div>广告状态: <span>{AdStatus[configuredStatus||'AD_STATUS_SUSPEND']}</span></div>
    </>
})

export default React.memo(AdgroupsCol)