import { AdStatus } from "@/services/launchAdq/enum"
import { DatePicker, Form, Input, Modal, Radio, Select } from "antd"
import React, { useEffect, useState } from "react"
import moment from 'moment';


/**
 * 设置名称
 * @returns 
 */
interface Props {
    data: any,
    visible?: boolean,
    onClose?: () => void,
    onChange?: (data: any) => void
    ajax?: any
}
const SubmitModal: React.FC<Props> = (props) => {

    /********************/
    const { visible, onClose, onChange, ajax, data } = props
    // const { endDate, beginDate, bidAmount } = data
    const [form] = Form.useForm()
    let dateType = Form.useWatch('dateType', form)
    const [initialValues, setInitialValues] = useState<{ configuredStatus?: string, dateType?: string, date?: [any, any], beginDate?: any, bidAmount?: number, firstDayBeginTime?: any }>({ dateType: '1', configuredStatus: 'AD_STATUS_SUSPEND' })
    /********************/

    // useEffect(() => {
    //     let params: { configuredStatus?: string, dateType?: string, date?: [any, any], beginDate?: any, bidAmount?: number, firstDayBeginTime?: any } = { bidAmount, configuredStatus: 'AD_STATUS_SUSPEND' }
    //     if (endDate) {
    //         params.dateType = '1'
    //         params.date = [moment(beginDate), moment(endDate)]
    //     } else {
    //         params.dateType = '2'
    //         params.beginDate = moment(beginDate)
    //     }
    //     setInitialValues(params)
    //     setTimeout(() => {
    //         form.resetFields();
    //     }, 50)
    // }, [])

    const handleOk = async () => {
        form.submit()
        let data = await form.validateFields()
        // const { dateType, date, beginDate, firstDayBeginTime, bidAmount, ...value } = data
        // let params: any = {}
        // if (dateType === '1') { // 选择开始与结束日期
        //     if (date) {
        //         params.beginDate = moment(date[0]).format('YYYY-MM-DD')
        //         params.endDate = moment(date[1]).format('YYYY-MM-DD')
        //     }
        // } else { // 长期投放
        //     if (beginDate) {
        //         params.beginDate = moment(beginDate).format('YYYY-MM-DD')
        //     }
        // }
        // if (firstDayBeginTime) {
        //     params.firstDayBeginTime = moment(firstDayBeginTime).format('hh:mm:ss')
        // }
        // if (bidAmount) {
        //     params.bidAmount = bidAmount
        // }
        onChange && onChange(data)
    }

    return <Modal title="设置名称" visible={visible} confirmLoading={ajax?.loading} onOk={handleOk} onCancel={() => { onClose && onClose() }}>
        <Form
            name="basic"
            form={form}
            labelCol={{ span: 4 }}
            wrapperCol={{ span: 20 }}
            autoComplete="off"
            initialValues={{ ...initialValues }}
        >
            {/* <Form.Item label={<strong>广告名称</strong>} name="adgroupName">
                <Input placeholder="请输入广告名称" />
            </Form.Item> */}
            <Form.Item label={<strong>计划名称</strong>} name="campaignName">
                <Input placeholder="请输入计划名称" />
            </Form.Item>
            {/* <Form.Item label={<strong>广告状态</strong>} name="configuredStatus" rules={[{ required: true, message: '请选择广告状态' }]}>
                <Select placeholder="选择广告状态">
                    {Object.keys(AdStatus).map(key => {
                        return <Select.Option value={key} key={key}>{AdStatus[key]}</Select.Option>
                    })}
                </Select>
            </Form.Item>
            <Form.Item label={<strong>投放日期</strong>} name='dateType'>
                <Radio.Group >
                    <Radio.Button value="1">选择开始与结束日期</Radio.Button>
                    <Radio.Button value="2">长期投放</Radio.Button>
                </Radio.Group>
            </Form.Item>
            {dateType === '1' && <Form.Item name='date' style={{ marginLeft: 78 }} rules={[{ required: true, message: '请选择日期' }]}>
                <DatePicker.RangePicker />
            </Form.Item>}
            {dateType === '2' && <Form.Item name='beginDate' style={{ marginLeft: 78 }} rules={[{ required: true, message: '请选择日期' }]}>
                <DatePicker />
            </Form.Item>}
            <Form.Item label={<strong>开始时间</strong>} name='firstDayBeginTime'>
                <DatePicker.TimePicker />
            </Form.Item>
            <Form.Item label={<strong>出价</strong>} name='bidAmount' rules={[{ required: true, message: '请输入价格' }]}>
                <Input placeholder='输入价格 元/千次曝光' />
            </Form.Item> */}
        </Form>
    </Modal>
}

export default React.memo(SubmitModal)