import { request } from 'umi';
import { api } from '../api';
/**
 * 定向标签获取
 * 
*/
export async function getTagsList(params:any){
    return request(api+`/adq/launch/tools/targeting/tags/list`,{
        method:'POST',
        data:params
    })
}
/**
 * 场景定向标签获取
 * */ 

 export async function getSceneTagsList(params:any){
    return request(api+`/adq/launch/tools/scene/spec/tags/list`,{
        method:'POST',
        data:params
    })
}
/**
 * 创意形式详细信息
 * @param promotedObjectType 推广目标
 * @param adcreativeTemplateId 创意形式ID
 * @param siteSet 数组版位 
 * https://developers.e.qq.com/docs/api/tools/adcreative_template/adcreative_template_get?version=1.3&_preview=1
 * https://developers.e.qq.com/docs/tools/adcreative_template
 * */ 

 export async function get_adcreative_template(params:any){
    return request(api+`/adq/launch/tools/adcreative/template`,{
        method:'POST',
        data:params
    })
}
/**
 * 创意形式列表信息
 * @param promotedObjectType 推广目标
 * @param siteSet 数组版位 
 * @param campaignType 投放位置
 * https://developers.e.qq.com/docs/api/tools/adcreative_template/adcreative_template_list_get?version=1.3&_preview=1
 * */ 

 export async function get_adcreative_template_list(params:any){
    return request(api+`/adq/launch/tools/adcreative/template/list`,{
        method:'POST',
        data:params
    })
}
/**
 * 文案助手
 * */
export async function getText(params:{
    maxTextLength:number,
    adAccountId:number,
}) {
    return request(api+`/adq/launch/tools/creative/tools/text`,{
        method:'GET',
        params
    })
    
} 
/**
 * 视频封面图生成
 * */ 
 export async function get_tools_video_capture(params:any){
    return request(api+`/adq/launch/tools/video/maker/capture`,{
        method:'POST',
        data:params
    })
}